#include <tigcclib.h>

#include "_X_Lib.h"
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// DEBUT CODE ///////////////////////////////////////////////////////////////////////////////////////////////////////////////

JoyPad_Button Press;

volatile unsigned long XTimer=0;

// Compatibilit TIGCC //////////////////////////////////////////////////////////

unsigned long *tigcc0,*tigcc1;
INT_HANDLER save_int_1, save_int_5;
INT_HANDLER save_int_1bis = NULL;


DEFINE_INT_HANDLER (Xhandler)  { XTimer++; }



// Fonction XGOn ////////////////////////////////////////////////////////////////
BOOL XGOn()
{
	save_int_1=GetIntVec(AUTO_INT_1);
	SetIntVec(AUTO_INT_1,DUMMY_HANDLER);
	save_int_5=GetIntVec(AUTO_INT_5);
	SetIntVec(AUTO_INT_5,Xhandler);
  if (!GrayOn ())
  {
	SetIntVec(AUTO_INT_5,save_int_5);
	SetIntVec(AUTO_INT_1,save_int_1);  	
  return FALSE;
	}
	tigcc0=GetPlane (0); 
	tigcc1=GetPlane (1); 
	return TRUE;
}

// Fonction XGOff ///////////////////////////////////////////////////////////////
void XGOff()
{ 
	XTimer=0;
	while(XTimer<10);
	GrayOff();
	SetIntVec(AUTO_INT_5,save_int_5);
	SetIntVec(AUTO_INT_1,save_int_1);
	GKeyFlush();
}

// Fonction XNewGplan /////////////////////////////////////////////////////////// 
void * XNewGPlan()
{
	unsigned long *p_plan;
	if(!(p_plan=malloc(XGPlan)))	return NULL;
	memset(p_plan,0,XGPlan);
	return p_plan;
}

// Fonction XNewBWplan ////////////////////////////////////////////////////////// 
void * XNewBWPlan()
{
	unsigned long *p_plan;
	if(!(p_plan=malloc(XBWPlan)))	return NULL;
	memset(p_plan,0,XBWPlan);
	return p_plan;
}




unsigned long CGplan;
unsigned long CBWplan;



// Code Asm //////////////////////////////////////////////////////////////////////////////////////////////

asm("
virtual_pc:
	dc.l	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

.global XGPlanc
XGPlanc:
	move.l	%a0,CGplan
	rts

XBWPlanc:
	move.l	%a0,CBWplan
	rts

.global XClrGPlan
XClrGPlan:
	move.l	CGplan,%a0
	lea			7680(%a0),%a0
	bsr.s		XClrPlan
	bsr.s		XClrPlan 
	rts

XClrLPlan:
	move.l	CGplan,%a0
	lea			3840(%a0),%a0
	bsr.s		XClrPlan	
	rts

XClrDPlan:
	move.l	CGplan,%a0
	lea			7680(%a0),%a0
	bsr.s		XClrPlan
	rts

XClrBWPlan:
	move.l	CBWplan,%a0
	lea			3840(%a0),%a0
	bsr.s		XClrPlan
	rts

XClrPlan:
	movem.l	%d3-%d7/%a2-%a7,virtual_pc
	moveq		#0,%d0
	moveq		#0,%d1
	moveq		#0,%d2
	moveq		#0,%d3
	moveq		#0,%d4
	moveq		#0,%d5
	moveq		#0,%d6
	moveq		#0,%d7
	move.l	%d1,%a1
	move.l	%d2,%a2
	move.l	%d3,%a3
	move.l	%d4,%a4
	move.l	%d5,%a5
	move.l	%d6,%a6
	move.l	%d7,%a7
	movem.l	%d0-%d7/%a1-%a7,-(%a0) 		 
	movem.l	%d0-%d7/%a1-%a7,-(%a0) 		 	
	movem.l	%d0-%d7/%a1-%a7,-(%a0) 		 	
	movem.l	%d0-%d7/%a1-%a7,-(%a0) 		 	
	movem.l	%d0-%d7/%a1-%a7,-(%a0) 		 
	movem.l	%d0-%d7/%a1-%a7,-(%a0) 		 	
	movem.l	%d0-%d7/%a1-%a7,-(%a0) 		 	
	movem.l	%d0-%d7/%a1-%a7,-(%a0) 		 	
	movem.l	%d0-%d7/%a1-%a7,-(%a0) 		 
	movem.l	%d0-%d7/%a1-%a7,-(%a0) 		 	
	movem.l	%d0-%d7/%a1-%a7,-(%a0) 		 	
	movem.l	%d0-%d7/%a1-%a7,-(%a0) 		 	
	movem.l	%d0-%d7/%a1-%a7,-(%a0) 		 
	movem.l	%d0-%d7/%a1-%a7,-(%a0) 		 	
	movem.l	%d0-%d7/%a1-%a7,-(%a0) 		 	
	movem.l	%d0-%d7/%a1-%a7,-(%a0) 		 	
	movem.l	%d0-%d7/%a1-%a7,-(%a0) 		 
	movem.l	%d0-%d7/%a1-%a7,-(%a0) 		 	
	movem.l	%d0-%d7/%a1-%a7,-(%a0) 		 	
	movem.l	%d0-%d7/%a1-%a7,-(%a0) 		 	
	movem.l	%d0-%d7/%a1-%a7,-(%a0) 		 
	movem.l	%d0-%d7/%a1-%a7,-(%a0) 		 	
	movem.l	%d0-%d7/%a1-%a7,-(%a0) 		 	
	movem.l	%d0-%d7/%a1-%a7,-(%a0) 		 	
	movem.l	%d0-%d7/%a1-%a7,-(%a0) 		 
	movem.l	%d0-%d7/%a1-%a7,-(%a0) 		 	
	movem.l	%d0-%d7/%a1-%a7,-(%a0) 		 	
	movem.l	%d0-%d7/%a1-%a7,-(%a0) 		 	
	movem.l	%d0-%d7/%a1-%a7,-(%a0) 		 
	movem.l	%d0-%d7/%a1-%a7,-(%a0) 		 	
	movem.l	%d0-%d7/%a1-%a7,-(%a0) 		 	
	movem.l	%d0-%d7/%a1-%a7,-(%a0) 		 	
	movem.l	%d0-%d7/%a1-%a7,-(%a0) 		 
	movem.l	%d0-%d7/%a1-%a7,-(%a0) 		 	
	movem.l	%d0-%d7/%a1-%a7,-(%a0) 		 	
	movem.l	%d0-%d7/%a1-%a7,-(%a0) 		 	
	movem.l	%d0-%d7/%a1-%a7,-(%a0) 		 
	movem.l	%d0-%d7/%a1-%a7,-(%a0) 		 	
	movem.l	%d0-%d7/%a1-%a7,-(%a0) 		 	
	movem.l	%d0-%d7/%a1-%a7,-(%a0) 		 	
	movem.l	%d0-%d7/%a1-%a7,-(%a0) 		 
	movem.l	%d0-%d7/%a1-%a7,-(%a0) 		 	
	movem.l	%d0-%d7/%a1-%a7,-(%a0) 		 	
	movem.l	%d0-%d7/%a1-%a7,-(%a0) 		 	
	movem.l	%d0-%d7/%a1-%a7,-(%a0) 		 
	movem.l	%d0-%d7/%a1-%a7,-(%a0) 		 	
	movem.l	%d0-%d7/%a1-%a7,-(%a0) 		 	
	movem.l	%d0-%d7/%a1-%a7,-(%a0) 		 	
	movem.l	%d0-%d7/%a1-%a7,-(%a0) 		 
	movem.l	%d0-%d7/%a1-%a7,-(%a0) 		 	
	movem.l	%d0-%d7/%a1-%a7,-(%a0) 		 	
	movem.l	%d0-%d7/%a1-%a7,-(%a0) 		 	
	movem.l	%d0-%d7/%a1-%a7,-(%a0) 		 
	movem.l	%d0-%d7/%a1-%a7,-(%a0) 		 	
	movem.l	%d0-%d7/%a1-%a7,-(%a0) 		 	
	movem.l	%d0-%d7/%a1-%a7,-(%a0) 		 	
	movem.l	%d0-%d7/%a1-%a7,-(%a0) 		 
	movem.l	%d0-%d7/%a1-%a7,-(%a0) 		 	
	movem.l	%d0-%d7/%a1-%a7,-(%a0) 		 	
	movem.l	%d0-%d7/%a1-%a7,-(%a0) 		 	
	movem.l	%d0-%d7/%a1-%a7,-(%a0) 		 
	movem.l	%d0-%d7/%a1-%a7,-(%a0) 		 	
	movem.l	%d0-%d7/%a1-%a7,-(%a0) 		 	
	movem.l	%d0-%d7/%a1-%a7,-(%a0) 		 	
	movem.l	virtual_pc,%d3-%d7/%a2-%a7
	rts

XCpyBWPlanToLPlan:
	move.l	CBWplan,%a0
	move.l	CGplan,%a1
	bsr.s		XCpyPlan 
	rts

XCpyBWPlanToDPlan:
	move.l	CBWplan,%a0
	move.l	CGplan,%a1
	lea			3840(%a1),%a1
	bsr.s		XCpyPlan
	rts

.global XCpyGPlanToLCD
XCpyGPlanToLCD:
	move.l	CGplan,%a0
	move.l	tigcc0,%a1	
	bsr.s		XCpyPlan
	move.l	tigcc1,%a1
	bsr.s		XCpyPlan
	rts

XCpyGPlanToInvLCD:
	move.l	CGplan,%a0
	move.l	tigcc1,%a1	
	bsr.s		XCpyPlan
	move.l	tigcc0,%a1
	bsr.s		XCpyPlan
	rts
	
XCpyLPlanToLCD:
	move.l	CGplan,%a0
	move.l	tigcc0,%a1	
	bsr.s		XCpyPlan
	rts

XCpyLPlanToDLCD:
	move.l	CGplan,%a0
	move.l	tigcc1,%a1	
	bsr.s		XCpyPlan
	rts

XCpyDPlanToLCD:
	move.l	CGplan,%a0
	lea			3840(%a0),%a0
	move.l	tigcc1,%a1
	bsr.s		XCpyPlan
	rts

XCpyDPlanToLLCD:
	move.l	CGplan,%a0
	lea			3840(%a0),%a0
	move.l	tigcc0,%a1
	bsr.s		XCpyPlan
	rts


XCpyPlan:
	movem.l	%d3-%d7/%a2-%a7,virtual_pc
	moveq   #6,%d0
XCpyPlan_loop:
	movem.l	(%a0)+,%d1-%d7/%a2-%a7
	movem.l	%d1-%d7/%a2-%a7,(%a1)
	movem.l	(%a0)+,%d1-%d7/%a2-%a7
	movem.l	%d1-%d7/%a2-%a7,52(%a1)
	movem.l	(%a0)+,%d1-%d7/%a2-%a7
	movem.l	%d1-%d7/%a2-%a7,104(%a1)
	movem.l	(%a0)+,%d1-%d7/%a2-%a7
	movem.l	%d1-%d7/%a2-%a7,156(%a1)
	movem.l	(%a0)+,%d1-%d7/%a2-%a7
	movem.l	%d1-%d7/%a2-%a7,208(%a1)
	movem.l	(%a0)+,%d1-%d7/%a2-%a7
	movem.l	%d1-%d7/%a2-%a7,260(%a1)
	movem.l	(%a0)+,%d1-%d7/%a2-%a7
	movem.l	%d1-%d7/%a2-%a7,312(%a1)
	movem.l	(%a0)+,%d1-%d7/%a2-%a7
	movem.l	%d1-%d7/%a2-%a7,364(%a1)
	movem.l	(%a0)+,%d1-%d7/%a2-%a7
	movem.l	%d1-%d7/%a2-%a7,416(%a1)
	movem.l	(%a0)+,%d1-%d7/%a2-%a7
	movem.l	%d1-%d7/%a2-%a7,468(%a1)
	lea			520(%a1),%a1
	dbra		%d0,XCpyPlan_loop
	movem.l	(%a0)+,%d1-%d7/%a2-%a7
	movem.l	%d1-%d7/%a2-%a7,(%a1)
	movem.l	(%a0)+,%d1-%d7/%a2-%a7
	movem.l	%d1-%d7/%a2-%a7,52(%a1)
	movem.l	(%a0)+,%d1-%d7/%a2-%a7
	movem.l	%d1-%d7/%a2-%a7,104(%a1)
	movem.l	(%a0)+,%d1-%d7/%a2-%a5
	movem.l	%d1-%d7/%a2-%a5,156(%a1)
	movem.l	virtual_pc,%d3-%d7/%a2-%a7
	rts
");





// JoyPad //

void XJoyPad()
{
	Press.Up=0;
	Press.Down=0;
	Press.Left=0;
	Press.Right=0;
	Press.Enter=0;
	Press.Esc=0;
	Press.Apps=0;
	Press.B1=0;
	Press.B2=0;
	Press.B3=0;
	Press.B4=0;
	

	if (TI89==TRUE)
	{
	Press.Down=_rowread(0x7E)&0x1;
	Press.Up=_rowread(0x7E)&0x4;
	Press.Right=_rowread(0x7E)&0x2;
	Press.Left=_rowread(0x7E)&0x8;
	Press.Enter=_rowread(0x7D)&0x1;
	Press.Esc=_rowread(0x3F)&0x1;
	Press.Apps=_rowread(0x5F)&0x1;
	Press.B1=_rowread(0x7E)&0x10;										//2nd
	Press.B2=_rowread(0x7E)&0x20;										//shift
	Press.B3=_rowread(0x7E)&0x40;										//diam
	Press.B4=_rowread(0x7E)&0x80;										//alpha
	return;
	}
 if (TI92PLUS==TRUE)
	{
	Press.Up=_rowread(0x3FE)&0x80;
	Press.Down=_rowread(0x3FE)&0x20;
	Press.Left=_rowread(0x3FE)&0x40;
	Press.Right=_rowread(0x3FE)&0x10;
	Press.Enter=_rowread(0x3BF)&0x40;
	Press.Esc=_rowread(0x2FF)&0x40;
	Press.Apps=_rowread(0x37F)&0x40;
	Press.B1=_rowread(0x3BF)&0x10;									// F1
	Press.B2=_rowread(0x37F)&0x10;									// F5
	Press.B3=_rowread(0x3EF)&0x10;									// F2
	Press.B4=_rowread(0x3DF)&0x10;									// F6
	return;
	}
	Press.Up=_rowread(0x3FE)&0x80;
	Press.Down=_rowread(0x3FE)&0x20;
	Press.Left=_rowread(0x3FE)&0x40;
	Press.Right=_rowread(0x3FE)&0x10;
	Press.Enter=_rowread(0x3BF)&0x40;
	Press.Esc=_rowread(0x2FF)&0x40;
	Press.Apps=_rowread(0x37F)&0x40;
/*	Press.B1=
	Press.B2=
	Press.B3=
	Press.B4=
*/
}



/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ FIN ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/