/* 
* TI-NESulator project : paddle.c
*
* Define NES Paddle
*
* Code Copyright  2003 by TRAPIER Manoel
*
*/

#include <tigcclib.h>

#include "paddle.h"

#include "X2D.h"

void InitPaddle(Paddle *pdl)
{
	pdl->Bit = 1;
	pdl->LastWrite = 0;
}

void WritePaddle(Paddle *pdl, unsigned char val)
{
	if ( (pdl->LastWrite == 1) && (val == 0) )
		InitPaddle(pdl);
	pdl->LastWrite = val;
}

unsigned char ReadPaddle(Paddle *pdl)
{
	XJoyPad();
	switch(pdl->Bit++)
	{
	case 1:
		if (Press.B1)
			return 1;
		break;
	case 2:
		if (Press.B2)
			return 1;
		break;
	case 3:
		if (Press.Apps)
			return 1;
		break;
	case 4:
		if (Press.Enter)
			return 1;
		break;
	case 5:
		if (Press.Down)
			return 1;
		break;
	case 6:
		if (Press.Up)
			return 1;
		break;
	case 7:
		if (Press.Right)
			return 1;
		break;
	case 8:
		if (Press.Left)
			return 1;
		break;
	case 20:
		return 1;
		break;
	case 24:
		pdl->Bit = 1;
		return 0;
	default:
		return 0;
		break;	
	}
	return 0;
}
